summaryrefslogtreecommitdiff
path: root/integrationtests/test-recoup.sh
diff options
context:
space:
mode:
authorTorsten Grote <t@grobox.de>2020-05-05 12:58:29 -0300
committerTorsten Grote <t@grobox.de>2020-05-05 12:58:29 -0300
commit85af5421e53f92f24919cb57c02efb6f72fb8e27 (patch)
tree764910a25331b8718c605f3f19ebd918dd46feb1 /integrationtests/test-recoup.sh
parentcd9a34cbb5ca8fb1c61aeda50517de60cc829e29 (diff)
downloadwallet-core-85af5421e53f92f24919cb57c02efb6f72fb8e27.tar.gz
wallet-core-85af5421e53f92f24919cb57c02efb6f72fb8e27.tar.bz2
wallet-core-85af5421e53f92f24919cb57c02efb6f72fb8e27.zip
Factor out common code from shell integration tests
and give code the shellcheck treatment
Diffstat (limited to 'integrationtests/test-recoup.sh')
-rwxr-xr-xintegrationtests/test-recoup.sh149
1 files changed, 14 insertions, 135 deletions
diff --git a/integrationtests/test-recoup.sh b/integrationtests/test-recoup.sh
index 198e1a19d..ea4d9380a 100755
--- a/integrationtests/test-recoup.sh
+++ b/integrationtests/test-recoup.sh
@@ -4,138 +4,25 @@
# Requires the wallet CLI to be installed and in the path. Furthermore, the
# user running this script must be Postgres superuser and be allowed to
# create/drop databases.
+# Also the jq utility needs to be installed
-set -eu
-
-trap "kill `jobs -p` &> /dev/null || true" ERR
-trap "kill `jobs -p` &> /dev/null || true" EXIT
-
-# Exit, with status code "skip" (no 'real' failure)
-function exit_skip() {
- echo $1
- exit 77
-}
+echo -n "Testing for jq"
+jq --version >/dev/null </dev/null || exit_skip " MISSING"
+echo " FOUND"
-# Where do we write the result?
-export BASEDB=${1:-"revoke-basedb"}
+source "common.sh"
+setup_config "recoup"
-# Name of the Postgres database we will use for the script.
-# Will be dropped, do NOT use anything that might be used
-# elsewhere
-export TARGET_DB=taler-auditor-revokedb
-TMP_DIR=`mktemp -d revocation-tmp-XXXXXX`
+TMP_DIR=$(mktemp -d revocation-tmp-XXXXXX)
export WALLET_DB=wallet-revocation.wallet.json
rm -f $WALLET_DB
-# Configuration file will be edited, so we create one
-# from the template.
-export CONF=test-recoup.conf
-cp template.conf $CONF
-
-
-echo -n "Testing for taler-bank-manage"
-taler-bank-manage -h >/dev/null </dev/null || exit_skip " MISSING"
-echo " FOUND"
-echo -n "Testing for taler-wallet-cli"
-taler-wallet-cli -v >/dev/null </dev/null || exit_skip " MISSING"
-echo " FOUND"
-
-
-
-# Clean up
-DATA_DIR=`taler-config -f -c $CONF -s PATHS -o TALER_HOME`
-rm -rf $DATA_DIR || true
-
-# reset database
-dropdb $TARGET_DB >/dev/null 2>/dev/null || true
-createdb $TARGET_DB || exit_skip "Could not create database $TARGET_DB"
-
-# obtain key configuration data
-MASTER_PRIV_FILE=`taler-config -f -c $CONF -s EXCHANGE -o MASTER_PRIV_FILE`
-MASTER_PRIV_DIR=`dirname $MASTER_PRIV_FILE`
-mkdir -p $MASTER_PRIV_DIR
-gnunet-ecc -g1 $MASTER_PRIV_FILE > /dev/null
-export MASTER_PUB=`gnunet-ecc -p $MASTER_PRIV_FILE`
-export EXCHANGE_URL=`taler-config -c $CONF -s EXCHANGE -o BASE_URL`
-MERCHANT_PORT=`taler-config -c $CONF -s MERCHANT -o PORT`
-export MERCHANT_URL=http://localhost:${MERCHANT_PORT}/
-BANK_PORT=`taler-config -c $CONF -s BANK -o HTTP_PORT`
-export BANK_URL=http://localhost:${BANK_PORT}/
-export AUDITOR_URL=http://localhost:8083/
-
-# patch configuration
-taler-config -c $CONF -s exchange -o MASTER_PUBLIC_KEY -V $MASTER_PUB
-taler-config -c $CONF -s merchant-exchange-default -o MASTER_KEY -V $MASTER_PUB
-taler-config -c $CONF -s exchangedb-postgres -o CONFIG -V postgres:///$TARGET_DB
-taler-config -c $CONF -s auditordb-postgres -o CONFIG -V postgres:///$TARGET_DB
-taler-config -c $CONF -s merchantdb-postgres -o CONFIG -V postgres:///$TARGET_DB
-taler-config -c $CONF -s bank -o database -V postgres:///$TARGET_DB
-taler-config -c $CONF -s exchange -o KEYDIR -V "${TMP_DIR}/keydir/"
-taler-config -c $CONF -s exchange -o REVOCATION_DIR -V "${TMP_DIR}/revdir/"
-
-# setup exchange
-echo "Setting up exchange"
-taler-exchange-dbinit -c $CONF
-taler-exchange-wire -c $CONF 2> taler-exchange-wire.log
-taler-exchange-keyup -L INFO -c $CONF -o e2a.dat 2> taler-exchange-keyup.log
-
-# setup auditor
-echo "Setting up auditor"
-taler-auditor-dbinit -c $CONF
-taler-auditor-exchange -c $CONF -m $MASTER_PUB -u $EXCHANGE_URL
-taler-auditor-sign -c $CONF -u $AUDITOR_URL -r e2a.dat -o a2e.dat -m $MASTER_PUB
-rm -f e2a.dat
-
-# provide auditor's signature to exchange
-ABD=`taler-config -c $CONF -s EXCHANGEDB -o AUDITOR_BASE_DIR -f`
-mkdir -p $ABD
-mv a2e.dat $ABD
-
-# Launch services
-echo "Launching services"
-taler-bank-manage-testing $CONF postgres:///$TARGET_DB serve-http &> revocation-bank.log &
-taler-exchange-httpd -c $CONF 2> taler-exchange-httpd.log &
-EXCHANGE_PID=$!
-taler-merchant-httpd -c $CONF -L INFO 2> taler-merchant-httpd.log &
-MERCHANT_PID=$!
-taler-exchange-wirewatch -c $CONF 2> taler-exchange-wirewatch.log &
-taler-auditor-httpd -c $CONF 2> taler-auditor-httpd.log &
-
-# Wait for all bank to be available (usually the slowest)
-for n in `seq 1 50`
-do
- echo -n "."
- sleep 0.2
- OK=0
- # bank
- wget http://localhost:8082/ -o /dev/null -O /dev/null >/dev/null || continue
- OK=1
- break
-done
-# Wait for all other services to be available
-for n in `seq 1 50`
-do
- echo -n "."
- sleep 0.1
- OK=0
- # exchange
- wget http://localhost:8081/ -o /dev/null -O /dev/null >/dev/null || continue
- # merchant
- wget http://localhost:9966/ -o /dev/null -O /dev/null >/dev/null || continue
- # Auditor
- wget http://localhost:8083/ -o /dev/null -O /dev/null >/dev/null || continue
- OK=1
- break
-done
-
+taler-config -c "$CONF" -s exchange -o KEYDIR -V "${TMP_DIR}/keydir/"
+taler-config -c "$CONF" -s exchange -o REVOCATION_DIR -V "${TMP_DIR}/revdir/"
-if [ 1 != $OK ]
-then
- kill `jobs -p`
- wait
- exit_skip "Failed to launch services"
-fi
-echo " DONE"
+setup_services
+launch_services
+wait_for_services
# run wallet CLI
echo "Running wallet"
@@ -288,15 +175,7 @@ taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB run-until-done
echo "Bought something with refresh-recouped coin"
-echo "Shutting down services"
-kill `jobs -p`
-wait
-
-# clean up
-echo "Final clean up (disabled)"
-dropdb $TARGET_DB
-rm -r $DATA_DIR || true
-rm $CONF
-rm -r $TMP_DIR
+shutdown_services
+rm -r "$TMP_DIR"
exit 0